****192c212,220
ALTER TABLE `discussion_threads` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`) 

>   PRIMARY KEY  (`id`), 
>   KEY `document_id` (`document_id`), 
>   KEY `first_comment_id` (`first_comment_id`), 
>   KEY `last_comment_id` (`last_comment_id`), 
>   KEY `creator_id` (`creator_id`), 
>   CONSTRAINT `discussion_threads_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `discussion_threads_ibfk_2` FOREIGN KEY (`first_comment_id`) REFERENCES `discussion_comments` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `discussion_threads_ibfk_3` FOREIGN KEY (`last_comment_id`) REFERENCES `discussion_comments` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `discussion_threads_ibfk_4` FOREIGN KEY (`creator_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****203c231,235
ALTER TABLE `document_archiving_link` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`) 

>   PRIMARY KEY  (`id`), 
>   KEY `document_id` (`document_id`), 
>   KEY `archiving_settings_id` (`archiving_settings_id`), 
>   CONSTRAINT `document_archiving_link_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `document_archiving_link_ibfk_2` FOREIGN KEY (`archiving_settings_id`) REFERENCES `archiving_settings` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****215c247
ALTER TABLE `document_content_version` MODIFY COLUMN 
<   `mime_id` int(11) NOT NULL default '0', 

>   `mime_id` int(11) default '9';
****219c251,253
ALTER TABLE `document_content_version` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 

>   PRIMARY KEY  (`id`), 
>   KEY `document_id` (`document_id`), 
>   KEY `mime_id` (`mime_id`);
****221c255,256
ALTER TABLE `document_content_version` MODIFY COLUMN 
<   KEY `document_id` (`document_id`) 

>   CONSTRAINT `document_content_version_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `document_content_version_ibfk_2` FOREIGN KEY (`mime_id`) REFERENCES `mime_types` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****238c273
ALTER TABLE `document_fields` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 

>   PRIMARY KEY  (`id`);
****240c275
ALTER TABLE `document_fields` MODIFY COLUMN 
<   CONSTRAINT `document_fields_ibfk_1` FOREIGN KEY (`parent_fieldset`) REFERENCES `fieldsets` (`id`) ON DELETE CASCADE 

>   CONSTRAINT `document_fields_ibfk_1` FOREIGN KEY (`parent_fieldset`) REFERENCES `fieldsets` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****252c287
ALTER TABLE `document_fields_link` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 

>   PRIMARY KEY  (`id`);
****255c290,291
ALTER TABLE `document_fields_link` MODIFY COLUMN 
<   CONSTRAINT `document_fields_link_ibfk_2` FOREIGN KEY (`document_field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE 

>   CONSTRAINT `document_fields_link_ibfk_1` FOREIGN KEY (`document_field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `document_fields_link_ibfk_2` FOREIGN KEY (`metadata_version_id`) REFERENCES `document_metadata_version` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****278c314,320
ALTER TABLE `document_link` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`) 

>   PRIMARY KEY  (`id`), 
>   KEY `parent_document_id` (`parent_document_id`), 
>   KEY `child_document_id` (`child_document_id`), 
>   KEY `link_type_id` (`link_type_id`), 
>   CONSTRAINT `document_link_ibfk_1` FOREIGN KEY (`parent_document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `document_link_ibfk_2` FOREIGN KEY (`child_document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `document_link_ibfk_3` FOREIGN KEY (`link_type_id`) REFERENCES `document_link_types` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****290c332
ALTER TABLE `document_link_types` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`) 

>   PRIMARY KEY  (`id`)
****310,312c352,354
ALTER TABLE `document_metadata_version` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 
<   KEY `fk_document_type_id` (`document_type_id`), 
<   KEY `fk_status_id` (`status_id`), 

>   PRIMARY KEY  (`id`), 
>   KEY `document_type_id` (`document_type_id`), 
>   KEY `status_id` (`status_id`);
****314d355
ALTER TABLE `document_metadata_version` DROP KEY `version_created` (`version_created`);
****319,324c360,367
ALTER TABLE `document_metadata_version` MODIFY COLUMN 
<   CONSTRAINT `document_metadata_version_ibfk_4` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `document_metadata_version_ibfk_5` FOREIGN KEY (`document_type_id`) REFERENCES `document_types_lookup` (`id`), 
<   CONSTRAINT `document_metadata_version_ibfk_6` FOREIGN KEY (`status_id`) REFERENCES `status_lookup` (`id`), 
<   CONSTRAINT `document_metadata_version_ibfk_7` FOREIGN KEY (`version_creator_id`) REFERENCES `users` (`id`), 
<   CONSTRAINT `document_metadata_version_ibfk_8` FOREIGN KEY (`workflow_id`) REFERENCES `workflows` (`id`), 
<   CONSTRAINT `document_metadata_version_ibfk_9` FOREIGN KEY (`workflow_state_id`) REFERENCES `workflow_states` (`id`) 

>   KEY `version_created` (`version_created`), 
>   CONSTRAINT `document_metadata_version_ibfk_1` FOREIGN KEY (`document_type_id`) REFERENCES `document_types_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `document_metadata_version_ibfk_2` FOREIGN KEY (`status_id`) REFERENCES `status_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `document_metadata_version_ibfk_3` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `document_metadata_version_ibfk_4` FOREIGN KEY (`version_creator_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `document_metadata_version_ibfk_5` FOREIGN KEY (`content_version_id`) REFERENCES `document_content_version` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `document_metadata_version_ibfk_6` FOREIGN KEY (`workflow_id`) REFERENCES `workflows` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `document_metadata_version_ibfk_7` FOREIGN KEY (`workflow_state_id`) REFERENCES `workflow_states` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****336,337c379,384
ALTER TABLE `document_role_allocations` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 
<   KEY `document_id` (`document_id`) 

>   PRIMARY KEY  (`id`), 
>   KEY `role_id` (`role_id`), 
>   KEY `permission_descriptor_id` (`permission_descriptor_id`), 
>   KEY `document_id_role_id` (`document_id`,`role_id`), 
>   CONSTRAINT `document_role_allocations_ibfk_1` FOREIGN KEY (`role_id`) REFERENCES `roles` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `document_role_allocations_ibfk_2` FOREIGN KEY (`permission_descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****347c394
ALTER TABLE `document_searchable_text` MODIFY COLUMN 
<   KEY `document_text_document_id_indx` (`document_id`), 

>   KEY `document_id` (`document_id`);
****360c407,411
ALTER TABLE `document_subscriptions` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`) 

>   PRIMARY KEY  (`id`), 
>   KEY `user_id` (`user_id`), 
>   KEY `document_id` (`document_id`), 
>   CONSTRAINT `document_subscriptions_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `document_subscriptions_ibfk_2` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****371,373c422,424
ALTER TABLE `document_tags` MODIFY COLUMN 
<   KEY `fk_document_tags_tag_id` (`tag_id`), 
<   CONSTRAINT `fk_document_tags_document_id` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
<   CONSTRAINT `fk_document_tags_tag_id` FOREIGN KEY (`tag_id`) REFERENCES `tag_words` (`id`) ON DELETE CASCADE ON UPDATE CASCADE 

>   KEY `tag_id` (`tag_id`), 
>   CONSTRAINT `document_tags_ibfk_2` FOREIGN KEY (`tag_id`) REFERENCES `tag_words` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `document_tags_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****381c432
ALTER TABLE `document_text` MODIFY COLUMN 
<   `document_id` int(11) default NULL, 

>   `document_id` int(11) NOT NULL default '0';
****383c434
ALTER TABLE `document_text` MODIFY COLUMN 
<   KEY `document_text_document_id_indx` (`document_id`), 

>   PRIMARY KEY  (`document_id`);
****392c443
ALTER TABLE `document_transaction_text` MODIFY COLUMN 
<   `document_id` int(11) default NULL, 

>   `document_id` int(11) NOT NULL default '0';
****394c445
ALTER TABLE `document_transaction_text` MODIFY COLUMN 
<   KEY `document_text_document_id_indx` (`document_id`), 

>   PRIMARY KEY  (`document_id`);
****406,407c457,458
ALTER TABLE `document_transaction_types_lookup` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 
<   KEY `namespace` (`namespace`) 

>   PRIMARY KEY  (`id`), 
>   UNIQUE KEY `namespace` (`namespace`)
****416c467
ALTER TABLE `document_transactions` MODIFY COLUMN 
<   `document_id` int(11) NOT NULL default '0', 

>   `document_id` int(11) default NULL;
****418c469
ALTER TABLE `document_transactions` MODIFY COLUMN 
<   `user_id` int(11) NOT NULL default '0', 

>   `user_id` int(11) default NULL;
****426,429c477,482
ALTER TABLE `document_transactions` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 
<   KEY `fk_document_id` (`document_id`), 
<   KEY `fk_user_id` (`user_id`), 
<   KEY `session_id` (`session_id`) 

>   PRIMARY KEY  (`id`), 
>   KEY `document_id` (`document_id`), 
>   KEY `user_id` (`user_id`), 
>   KEY `session_id` (`session_id`), 
>   CONSTRAINT `document_transactions_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE SET NULL ON UPDATE SET NULL, 
>   CONSTRAINT `document_transactions_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE SET NULL ON UPDATE SET NULL
****441c494,498
ALTER TABLE `document_type_fields_link` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`) 

>   PRIMARY KEY  (`id`), 
>   KEY `document_type_id` (`document_type_id`), 
>   KEY `field_id` (`field_id`), 
>   CONSTRAINT `document_type_fields_link_ibfk_1` FOREIGN KEY (`document_type_id`) REFERENCES `document_types_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `document_type_fields_link_ibfk_2` FOREIGN KEY (`field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****452c509
ALTER TABLE `document_type_fieldsets_link` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 

>   PRIMARY KEY  (`id`);
****455,456c512,513
ALTER TABLE `document_type_fieldsets_link` MODIFY COLUMN 
<   CONSTRAINT `document_type_fieldsets_link_ibfk_1` FOREIGN KEY (`document_type_id`) REFERENCES `document_types_lookup` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `document_type_fieldsets_link_ibfk_2` FOREIGN KEY (`fieldset_id`) REFERENCES `fieldsets` (`id`) ON DELETE CASCADE 

>   CONSTRAINT `document_type_fieldsets_link_ibfk_1` FOREIGN KEY (`document_type_id`) REFERENCES `document_types_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `document_type_fieldsets_link_ibfk_2` FOREIGN KEY (`fieldset_id`) REFERENCES `fieldsets` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****467,469c524,525
ALTER TABLE `document_types_lookup` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 
<   UNIQUE KEY `name` (`name`), 
<   KEY `disabled` (`disabled`) 

>   PRIMARY KEY  (`id`), 
>   KEY `name` (`name`)
****478c534
ALTER TABLE `documents` MODIFY COLUMN 
<   `creator_id` int(11) NOT NULL default '0', 

>   `creator_id` int(11) default NULL;
****490c546
ALTER TABLE `documents` MODIFY COLUMN 
<   `modified_user_id` int(11) NOT NULL default '0', 

>   `modified_user_id` int(11) default NULL;
****492c548
ALTER TABLE `documents` MODIFY COLUMN 
<   `owner_id` int(11) NOT NULL default '0', 

>   `owner_id` int(11) default NULL;
****497,502c553,557
ALTER TABLE `documents` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 
<   KEY `fk_creator_id` (`creator_id`), 
<   KEY `fk_folder_id` (`folder_id`), 
<   KEY `fk_checked_out_user_id` (`checked_out_user_id`), 
<   KEY `fk_status_id` (`status_id`), 
<   KEY `created` (`created`), 

>   PRIMARY KEY  (`id`), 
>   KEY `creator_id` (`creator_id`), 
>   KEY `folder_id` (`folder_id`), 
>   KEY `checked_out_user_id` (`checked_out_user_id`), 
>   KEY `status_id` (`status_id`);
****506c561,570
ALTER TABLE `documents` MODIFY COLUMN 
<   KEY `metadata_version_id` (`metadata_version_id`) 

>   KEY `metadata_version_id` (`metadata_version_id`), 
>   KEY `created` (`created`), 
>   CONSTRAINT `documents_ibfk_1` FOREIGN KEY (`creator_id`) REFERENCES `users` (`id`) ON DELETE SET NULL ON UPDATE SET NULL, 
>   CONSTRAINT `documents_ibfk_2` FOREIGN KEY (`folder_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `documents_ibfk_3` FOREIGN KEY (`checked_out_user_id`) REFERENCES `users` (`id`) ON DELETE SET NULL ON UPDATE SET NULL, 
>   CONSTRAINT `documents_ibfk_4` FOREIGN KEY (`status_id`) REFERENCES `status_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `documents_ibfk_5` FOREIGN KEY (`permission_object_id`) REFERENCES `permission_objects` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `documents_ibfk_6` FOREIGN KEY (`permission_lookup_id`) REFERENCES `permission_lookups` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `documents_ibfk_7` FOREIGN KEY (`modified_user_id`) REFERENCES `users` (`id`) ON DELETE SET NULL ON UPDATE SET NULL, 
>   CONSTRAINT `documents_ibfk_8` FOREIGN KEY (`metadata_version_id`) REFERENCES `document_metadata_version` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****514c578
ALTER TABLE `download_files` MODIFY COLUMN 
<   `document_id` int(10) unsigned NOT NULL, 

>   `document_id` int(11) NOT NULL;
****521c585,586
ALTER TABLE `download_files` MODIFY COLUMN 
<   PRIMARY KEY  (`document_id`,`session`) 

>   PRIMARY KEY  (`document_id`,`session`), 
>   CONSTRAINT `download_files_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****532d596
ALTER TABLE `field_behaviour_options` DROP KEY `behaviour_id` (`behaviour_id`);
****535,537c599,602
ALTER TABLE `field_behaviour_options` MODIFY COLUMN 
<   CONSTRAINT `field_behaviour_options_ibfk_1` FOREIGN KEY (`behaviour_id`) REFERENCES `field_behaviours` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `field_behaviour_options_ibfk_2` FOREIGN KEY (`field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `field_behaviour_options_ibfk_3` FOREIGN KEY (`instance_id`) REFERENCES `field_value_instances` (`id`) ON DELETE CASCADE 

>   KEY `behaviour_id_field_id` (`behaviour_id`,`field_id`), 
>   CONSTRAINT `field_behaviour_options_ibfk_1` FOREIGN KEY (`behaviour_id`) REFERENCES `field_behaviours` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `field_behaviour_options_ibfk_2` FOREIGN KEY (`field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `field_behaviour_options_ibfk_3` FOREIGN KEY (`instance_id`) REFERENCES `field_value_instances` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****552c617
ALTER TABLE `field_behaviours` MODIFY COLUMN 
<   CONSTRAINT `field_behaviours_ibfk_1` FOREIGN KEY (`field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE 

>   CONSTRAINT `field_behaviours_ibfk_1` FOREIGN KEY (`field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****563,564c628,629
ALTER TABLE `field_orders` MODIFY COLUMN 
<   UNIQUE KEY `child_field` (`child_field_id`), 
<   KEY `parent_field` (`parent_field_id`), 

>   UNIQUE KEY `child_field_id` (`child_field_id`), 
>   KEY `parent_field_id` (`parent_field_id`);
****566,568c631,633
ALTER TABLE `field_orders` MODIFY COLUMN 
<   CONSTRAINT `field_orders_ibfk_1` FOREIGN KEY (`parent_field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `field_orders_ibfk_2` FOREIGN KEY (`child_field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `field_orders_ibfk_3` FOREIGN KEY (`fieldset_id`) REFERENCES `fieldsets` (`id`) ON DELETE CASCADE 

>   CONSTRAINT `field_orders_ibfk_1` FOREIGN KEY (`child_field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `field_orders_ibfk_2` FOREIGN KEY (`parent_field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `field_orders_ibfk_3` FOREIGN KEY (`fieldset_id`) REFERENCES `fieldsets` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****581d645
ALTER TABLE `field_value_instances` DROP KEY `field_id` (`field_id`);
****584,586c648,651
ALTER TABLE `field_value_instances` MODIFY COLUMN 
<   CONSTRAINT `field_value_instances_ibfk_1` FOREIGN KEY (`field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `field_value_instances_ibfk_2` FOREIGN KEY (`field_value_id`) REFERENCES `metadata_lookup` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `field_value_instances_ibfk_3` FOREIGN KEY (`behaviour_id`) REFERENCES `field_behaviours` (`id`) ON DELETE CASCADE 

>   KEY `field_id` (`field_id`), 
>   CONSTRAINT `field_value_instances_ibfk_1` FOREIGN KEY (`field_value_id`) REFERENCES `metadata_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `field_value_instances_ibfk_2` FOREIGN KEY (`behaviour_id`) REFERENCES `field_behaviours` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `field_value_instances_ibfk_3` FOREIGN KEY (`field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****606c671,672
ALTER TABLE `fieldsets` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 

>   PRIMARY KEY  (`id`), 
>   KEY `master_field` (`master_field`);
****610,611c676,689
<   KEY `master_field` (`master_field`), 
<   CONSTRAINT `fieldsets_ibfk_1` FOREIGN KEY (`master_field`) REFERENCES `document_fields` (`id`) ON DELETE SET NULL 

>   CONSTRAINT `fieldsets_ibfk_1` FOREIGN KEY (`master_field`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE 
> ) ENGINE=InnoDB DEFAULT CHARSET=utf8; 
> 
> -- 
> -- Table structure for table `folder_descendants` 
> -- 
> 
> CREATE TABLE `folder_descendants` ( 
>   `parent_id` int(11) NOT NULL, 
>   `folder_id` int(11) NOT NULL, 
>   KEY `parent_id` (`parent_id`), 
>   KEY `folder_id` (`folder_id`), 
>   CONSTRAINT `folder_descendants_ibfk_2` FOREIGN KEY (`folder_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `folder_descendants_ibfk_1` FOREIGN KEY (`parent_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****622,624c700,704
ALTER TABLE `folder_doctypes_link` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 
<   KEY `fk_folder_id` (`folder_id`), 
<   KEY `fk_document_type_id` (`document_type_id`) 

>   PRIMARY KEY  (`id`), 
>   KEY `folder_id` (`folder_id`), 
>   KEY `document_type_id` (`document_type_id`), 
>   CONSTRAINT `folder_doctypes_link_ibfk_1` FOREIGN KEY (`folder_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `folder_doctypes_link_ibfk_2` FOREIGN KEY (`document_type_id`) REFERENCES `document_types_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****635d714
ALTER TABLE `folder_searchable_text` DROP KEY `folder_searchable_text_folder_indx` (`folder_id`);
****648c727,731
ALTER TABLE `folder_subscriptions` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`) 

>   PRIMARY KEY  (`id`), 
>   KEY `user_id` (`user_id`), 
>   KEY `folder_id` (`folder_id`), 
>   CONSTRAINT `folder_subscriptions_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `folder_subscriptions_ibfk_2` FOREIGN KEY (`folder_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****657,658c740,741
ALTER TABLE `folder_transactions` MODIFY COLUMN 
<   `folder_id` int(11) NOT NULL default '0', 
<   `user_id` int(11) NOT NULL default '0', 

>   `folder_id` int(11) default NULL, 
>   `user_id` int(11) default NULL;
****665c748
ALTER TABLE `folder_transactions` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 

>   PRIMARY KEY  (`id`);
****669,670c752,753
ALTER TABLE `folder_transactions` MODIFY COLUMN 
<   CONSTRAINT `folder_transactions_ibfk_1` FOREIGN KEY (`folder_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `folder_transactions_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE 

>   CONSTRAINT `folder_transactions_ibfk_1` FOREIGN KEY (`folder_id`) REFERENCES `folders` (`id`) ON DELETE SET NULL ON UPDATE SET NULL, 
>   CONSTRAINT `folder_transactions_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE SET NULL ON UPDATE SET NULL
****681c764,766
ALTER TABLE `folder_workflow_map` MODIFY COLUMN 
<   UNIQUE KEY `folder_id` (`folder_id`) 

>   KEY `workflow_id` (`workflow_id`), 
>   CONSTRAINT `folder_workflow_map_ibfk_1` FOREIGN KEY (`folder_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `folder_workflow_map_ibfk_2` FOREIGN KEY (`workflow_id`) REFERENCES `workflows` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****700,703c785,787
ALTER TABLE `folders` MODIFY COLUMN 
<   `owner_id` int(11) NOT NULL default '0', 
<   UNIQUE KEY `id` (`id`), 
<   KEY `fk_parent_id` (`parent_id`), 
<   KEY `fk_creator_id` (`creator_id`), 

>   `owner_id` int(11) default NULL, 
>   PRIMARY KEY  (`id`), 
>   KEY `creator_id` (`creator_id`);
****705c789,794
ALTER TABLE `folders` MODIFY COLUMN 
<   KEY `permission_lookup_id` (`permission_lookup_id`) 

>   KEY `permission_lookup_id` (`permission_lookup_id`), 
>   KEY `parent_id_name` (`parent_id`,`name`), 
>   CONSTRAINT `folders_ibfk_1` FOREIGN KEY (`creator_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `folders_ibfk_2` FOREIGN KEY (`permission_object_id`) REFERENCES `permission_objects` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `folders_ibfk_3` FOREIGN KEY (`permission_lookup_id`) REFERENCES `permission_lookups` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `folders_ibfk_4` FOREIGN KEY (`parent_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****721c810,814
ALTER TABLE `folders_users_roles_link` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`) 

>   PRIMARY KEY  (`id`), 
>   KEY `user_id` (`user_id`), 
>   KEY `document_id` (`document_id`), 
>   CONSTRAINT `folders_users_roles_link_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `folders_users_roles_link_ibfk_2` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****733,736c826,829
ALTER TABLE `groups_groups_link` MODIFY COLUMN 
<   KEY `groups_groups_link_ibfk_1` (`parent_group_id`), 
<   KEY `groups_groups_link_ibfk_2` (`member_group_id`), 
<   CONSTRAINT `groups_groups_link_ibfk_1` FOREIGN KEY (`parent_group_id`) REFERENCES `groups_lookup` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `groups_groups_link_ibfk_2` FOREIGN KEY (`member_group_id`) REFERENCES `groups_lookup` (`id`) ON DELETE CASCADE 

>   KEY `parent_group_id` (`parent_group_id`), 
>   KEY `member_group_id` (`member_group_id`), 
>   CONSTRAINT `groups_groups_link_ibfk_1` FOREIGN KEY (`parent_group_id`) REFERENCES `groups_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `groups_groups_link_ibfk_2` FOREIGN KEY (`member_group_id`) REFERENCES `groups_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****752c845
ALTER TABLE `groups_lookup` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 

>   PRIMARY KEY  (`id`);
****755,757c848,849
ALTER TABLE `groups_lookup` MODIFY COLUMN 
<   KEY `authentication_details_s1` (`authentication_details_s1`), 
<   KEY `authentication_source_id` (`authentication_source_id`), 
<   CONSTRAINT `groups_lookup_ibfk_1` FOREIGN KEY (`unit_id`) REFERENCES `units_lookup` (`id`) 

>   KEY `authentication_source_id_authentication_details_s1` (`authentication_source_id`,`authentication_details_s1`), 
>   CONSTRAINT `groups_lookup_ibfk_1` FOREIGN KEY (`unit_id`) REFERENCES `units_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****768c860
ALTER TABLE `help` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`) 

>   PRIMARY KEY  (`id`)
****788,789c880,881
ALTER TABLE `index_files` MODIFY COLUMN 
<   `document_id` int(10) unsigned NOT NULL, 
<   `user_id` int(10) unsigned NOT NULL, 

>   `document_id` int(11) NOT NULL, 
>   `user_id` int(11) NOT NULL;
****793c885,888
ALTER TABLE `index_files` MODIFY COLUMN 
<   PRIMARY KEY  (`document_id`) 

>   PRIMARY KEY  (`document_id`), 
>   KEY `user_id` (`user_id`), 
>   CONSTRAINT `index_files_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `index_files_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****818c913
ALTER TABLE `links` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`) 

>   PRIMARY KEY  (`id`)
****832c927,928
ALTER TABLE `metadata_lookup` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 

>   PRIMARY KEY  (`id`), 
>   KEY `document_field_id` (`document_field_id`);
****834c930
ALTER TABLE `metadata_lookup` MODIFY COLUMN 
<   KEY `is_stuck` (`is_stuck`) 

>   CONSTRAINT `metadata_lookup_ibfk_1` FOREIGN KEY (`document_field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****846c942,943
ALTER TABLE `metadata_lookup_tree` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 

>   PRIMARY KEY  (`id`), 
>   KEY `document_field_id` (`document_field_id`);
****848c945
ALTER TABLE `metadata_lookup_tree` MODIFY COLUMN 
<   KEY `document_field_id` (`document_field_id`) 

>   CONSTRAINT `metadata_lookup_tree_ibfk_1` FOREIGN KEY (`document_field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****874c971,975
ALTER TABLE `mime_types` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`) 

>   PRIMARY KEY  (`id`), 
>   KEY `mime_document_id` (`mime_document_id`), 
>   KEY `filetypes` (`filetypes`), 
>   KEY `mimetypes` (`mimetypes`), 
>   CONSTRAINT `mime_types_ibfk_1` FOREIGN KEY (`mime_document_id`) REFERENCES `mime_documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****890c991,993
ALTER TABLE `news` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`) 

>   PRIMARY KEY  (`id`), 
>   KEY `image_mime_type_id` (`image_mime_type_id`), 
>   CONSTRAINT `news_ibfk_1` FOREIGN KEY (`image_mime_type_id`) REFERENCES `mime_types` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****908,910c1011,1014
ALTER TABLE `notifications` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 
<   KEY `type` (`type`), 
<   KEY `user_id` (`user_id`) 

>   PRIMARY KEY  (`id`), 
>   KEY `user_id` (`user_id`), 
>   KEY `data_int_1` (`data_int_1`), 
>   CONSTRAINT `notifications_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****920c1024
ALTER TABLE `organisations_lookup` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 

>   PRIMARY KEY  (`id`);
****934c1038
ALTER TABLE `permission_assignments` MODIFY COLUMN 
<   UNIQUE KEY `permission_and_object` (`permission_id`,`permission_object_id`), 

>   UNIQUE KEY `permission_object_id_permission_id` (`permission_object_id`,`permission_id`);
****936d1039
ALTER TABLE `permission_assignments` DROP KEY `permission_object_id` (`permission_object_id`);
****938,940c1041,1043
ALTER TABLE `permission_assignments` MODIFY COLUMN 
<   CONSTRAINT `permission_assignments_ibfk_1` FOREIGN KEY (`permission_id`) REFERENCES `permissions` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `permission_assignments_ibfk_2` FOREIGN KEY (`permission_object_id`) REFERENCES `permission_objects` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `permission_assignments_ibfk_3` FOREIGN KEY (`permission_descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE 

>   CONSTRAINT `permission_assignments_ibfk_1` FOREIGN KEY (`permission_id`) REFERENCES `permissions` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `permission_assignments_ibfk_2` FOREIGN KEY (`permission_object_id`) REFERENCES `permission_objects` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `permission_assignments_ibfk_3` FOREIGN KEY (`permission_descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****950,951c1053
ALTER TABLE `permission_descriptor_groups` MODIFY COLUMN 
<   UNIQUE KEY `descriptor_id` (`descriptor_id`,`group_id`), 
<   KEY `descriptor_id_2` (`descriptor_id`), 

>   PRIMARY KEY  (`descriptor_id`,`group_id`);
****953,954c1055,1056
ALTER TABLE `permission_descriptor_groups` MODIFY COLUMN 
<   CONSTRAINT `permission_descriptor_groups_ibfk_1` FOREIGN KEY (`descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `permission_descriptor_groups_ibfk_2` FOREIGN KEY (`group_id`) REFERENCES `groups_lookup` (`id`) ON DELETE CASCADE 

>   CONSTRAINT `permission_descriptor_groups_ibfk_1` FOREIGN KEY (`descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `permission_descriptor_groups_ibfk_2` FOREIGN KEY (`group_id`) REFERENCES `groups_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****964,965c1066
ALTER TABLE `permission_descriptor_roles` MODIFY COLUMN 
<   UNIQUE KEY `descriptor_id` (`descriptor_id`,`role_id`), 
<   KEY `descriptor_id_2` (`descriptor_id`), 

>   PRIMARY KEY  (`descriptor_id`,`role_id`);
****967,968c1068,1069
ALTER TABLE `permission_descriptor_roles` MODIFY COLUMN 
<   CONSTRAINT `permission_descriptor_roles_ibfk_1` FOREIGN KEY (`descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `permission_descriptor_roles_ibfk_2` FOREIGN KEY (`role_id`) REFERENCES `roles` (`id`) ON DELETE CASCADE 

>   CONSTRAINT `permission_descriptor_roles_ibfk_1` FOREIGN KEY (`descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `permission_descriptor_roles_ibfk_2` FOREIGN KEY (`role_id`) REFERENCES `roles` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****978,979c1079
ALTER TABLE `permission_descriptor_users` MODIFY COLUMN 
<   UNIQUE KEY `descriptor_id` (`descriptor_id`,`user_id`), 
<   KEY `descriptor_id_2` (`descriptor_id`), 

>   PRIMARY KEY  (`descriptor_id`,`user_id`);
****981,982c1081,1082
ALTER TABLE `permission_descriptor_users` MODIFY COLUMN 
<   CONSTRAINT `permission_descriptor_users_ibfk_1` FOREIGN KEY (`descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `permission_descriptor_users_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE 

>   CONSTRAINT `permission_descriptor_users_ibfk_1` FOREIGN KEY (`descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `permission_descriptor_users_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****994,995c1094
ALTER TABLE `permission_descriptors` MODIFY COLUMN 
<   UNIQUE KEY `descriptor_2` (`descriptor`), 
<   KEY `descriptor` (`descriptor`) 

>   UNIQUE KEY `descriptor` (`descriptor`)
****1005c1104
ALTER TABLE `permission_dynamic_assignments` MODIFY COLUMN 
<   KEY `dynamic_conditiond_id` (`dynamic_condition_id`), 

>   KEY `dynamic_condition_id` (`dynamic_condition_id`);
****1007,1008c1106,1107
ALTER TABLE `permission_dynamic_assignments` MODIFY COLUMN 
<   CONSTRAINT `permission_dynamic_assignments_ibfk_2` FOREIGN KEY (`dynamic_condition_id`) REFERENCES `permission_dynamic_conditions` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `permission_dynamic_assignments_ibfk_3` FOREIGN KEY (`permission_id`) REFERENCES `permissions` (`id`) ON DELETE CASCADE 

>   CONSTRAINT `permission_dynamic_assignments_ibfk_2` FOREIGN KEY (`permission_id`) REFERENCES `permissions` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `permission_dynamic_assignments_ibfk_1` FOREIGN KEY (`dynamic_condition_id`) REFERENCES `permission_dynamic_conditions` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1024,1026c1123,1125
ALTER TABLE `permission_dynamic_conditions` MODIFY COLUMN 
<   CONSTRAINT `permission_dynamic_conditions_ibfk_1` FOREIGN KEY (`permission_object_id`) REFERENCES `permission_objects` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `permission_dynamic_conditions_ibfk_2` FOREIGN KEY (`group_id`) REFERENCES `groups_lookup` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `permission_dynamic_conditions_ibfk_3` FOREIGN KEY (`condition_id`) REFERENCES `saved_searches` (`id`) ON DELETE CASCADE 

>   CONSTRAINT `permission_dynamic_conditions_ibfk_1` FOREIGN KEY (`permission_object_id`) REFERENCES `permission_objects` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `permission_dynamic_conditions_ibfk_2` FOREIGN KEY (`group_id`) REFERENCES `groups_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `permission_dynamic_conditions_ibfk_3` FOREIGN KEY (`condition_id`) REFERENCES `saved_searches` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1039c1138
ALTER TABLE `permission_lookup_assignments` MODIFY COLUMN 
<   UNIQUE KEY `permission_and_lookup` (`permission_id`,`permission_lookup_id`), 

>   UNIQUE KEY `permission_lookup_id_permission_id` (`permission_lookup_id`,`permission_id`);
****1041d1139
ALTER TABLE `permission_lookup_assignments` DROP KEY `permission_lookup_id` (`permission_lookup_id`);
****1043,1045c1141,1143
ALTER TABLE `permission_lookup_assignments` MODIFY COLUMN 
<   CONSTRAINT `permission_lookup_assignments_ibfk_1` FOREIGN KEY (`permission_id`) REFERENCES `permissions` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `permission_lookup_assignments_ibfk_2` FOREIGN KEY (`permission_lookup_id`) REFERENCES `permission_lookups` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `permission_lookup_assignments_ibfk_3` FOREIGN KEY (`permission_descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE 

>   CONSTRAINT `permission_lookup_assignments_ibfk_1` FOREIGN KEY (`permission_id`) REFERENCES `permissions` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `permission_lookup_assignments_ibfk_2` FOREIGN KEY (`permission_lookup_id`) REFERENCES `permission_lookups` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `permission_lookup_assignments_ibfk_3` FOREIGN KEY (`permission_descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1088,1089c1186,1189
ALTER TABLE `plugin_rss` MODIFY COLUMN 
<   PRIMARY KEY  (`id`) 
< ) ENGINE=MyISAM DEFAULT CHARSET=utf8; 

>   PRIMARY KEY  (`id`), 
>   KEY `user_id` (`user_id`), 
>   CONSTRAINT `plugin_rss_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE 
> ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
****1105c1205,1206
ALTER TABLE `plugins` MODIFY COLUMN 
<   KEY `name` (`namespace`) 

>   UNIQUE KEY `namespace` (`namespace`), 
>   KEY `disabled` (`disabled`)
****1117,1118c1218,1224
ALTER TABLE `role_allocations` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 
<   KEY `folder_id` (`folder_id`) 

>   PRIMARY KEY  (`id`), 
>   KEY `folder_id` (`folder_id`), 
>   KEY `role_id` (`role_id`), 
>   KEY `permission_descriptor_id` (`permission_descriptor_id`), 
>   CONSTRAINT `role_allocations_ibfk_1` FOREIGN KEY (`folder_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `role_allocations_ibfk_2` FOREIGN KEY (`role_id`) REFERENCES `roles` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `role_allocations_ibfk_3` FOREIGN KEY (`permission_descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1128c1234
ALTER TABLE `roles` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 

>   PRIMARY KEY  (`id`);
****1145,1147c1251
ALTER TABLE `saved_searches` MODIFY COLUMN 
<   KEY `namespace` (`namespace`), 
<   KEY `is_condition` (`is_condition`), 
<   KEY `is_complete` (`is_complete`), 

>   UNIQUE KEY `namespace` (`namespace`);
****1165,1167c1269,1272
ALTER TABLE `scheduler_tasks` MODIFY COLUMN 
<   `run_time` datetime, 
<   `previous_run_time` datetime, 
<   `run_duration` float default NULL 

>   `run_time` datetime default NULL, 
>   `previous_run_time` datetime default NULL, 
>   `run_duration` float default NULL, 
>   PRIMARY KEY  (`id`)
****1177,1178c1282,1285
ALTER TABLE `search_document_user_link` MODIFY COLUMN 
<   KEY `fk_user_id` (`user_id`), 
<   KEY `fk_document_ids` (`document_id`) 

>   KEY `document_id` (`document_id`), 
>   KEY `user_id` (`user_id`), 
>   CONSTRAINT `search_document_user_link_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `search_document_user_link_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1204c1311,1313
ALTER TABLE `search_saved` MODIFY COLUMN 
<   PRIMARY KEY  (`id`) 

>   PRIMARY KEY  (`id`), 
>   KEY `user_id` (`user_id`), 
>   CONSTRAINT `search_saved_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1212c1321,1323
ALTER TABLE `search_saved_events` MODIFY COLUMN 
<   `document_id` int(11) NOT NULL 

>   `document_id` int(11) NOT NULL, 
>   PRIMARY KEY  (`document_id`), 
>   CONSTRAINT `search_saved_events_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1222c1333
ALTER TABLE `status_lookup` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`) 

>   PRIMARY KEY  (`id`)
****1233c1344,1345
ALTER TABLE `system_settings` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`) 

>   PRIMARY KEY  (`id`), 
>   UNIQUE KEY `name` (`name`)
****1254c1366,1368
ALTER TABLE `time_period` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`) 

>   PRIMARY KEY  (`id`), 
>   KEY `time_unit_id` (`time_unit_id`), 
>   CONSTRAINT `time_period_ibfk_1` FOREIGN KEY (`time_unit_id`) REFERENCES `time_unit_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1264c1378
ALTER TABLE `time_unit_lookup` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`) 

>   PRIMARY KEY  (`id`)
****1274,1275c1388
ALTER TABLE `trigger_selection` MODIFY COLUMN 
<   PRIMARY KEY  (`event_ns`), 
<   UNIQUE KEY `event_ns` (`event_ns`) 

>   PRIMARY KEY  (`event_ns`)
****1284c1397
ALTER TABLE `type_workflow_map` MODIFY COLUMN 
<   `workflow_id` int(10) unsigned default NULL, 

>   `workflow_id` int(11) default NULL;
****1286c1399,1401
ALTER TABLE `type_workflow_map` MODIFY COLUMN 
<   UNIQUE KEY `document_type_id` (`document_type_id`) 

>   KEY `workflow_id` (`workflow_id`), 
>   CONSTRAINT `type_workflow_map_ibfk_1` FOREIGN KEY (`document_type_id`) REFERENCES `document_types_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `type_workflow_map_ibfk_2` FOREIGN KEY (`workflow_id`) REFERENCES `workflows` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1297c1412
ALTER TABLE `units_lookup` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 

>   PRIMARY KEY  (`id`);
****1299c1414,1415
ALTER TABLE `units_lookup` MODIFY COLUMN 
<   UNIQUE KEY `folder_id` (`folder_id`) 

>   UNIQUE KEY `folder_id` (`folder_id`), 
>   CONSTRAINT `units_lookup_ibfk_1` FOREIGN KEY (`folder_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1310,1312c1426,1430
ALTER TABLE `units_organisations_link` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 
<   KEY `fk_unit_id` (`unit_id`), 
<   KEY `fk_organisation_id` (`organisation_id`) 

>   PRIMARY KEY  (`id`), 
>   KEY `unit_id` (`unit_id`), 
>   KEY `organisation_id` (`organisation_id`), 
>   CONSTRAINT `units_organisations_link_ibfk_1` FOREIGN KEY (`unit_id`) REFERENCES `units_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `units_organisations_link_ibfk_2` FOREIGN KEY (`organisation_id`) REFERENCES `organisations_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1341c1459,1464
ALTER TABLE `uploaded_files` MODIFY COLUMN 
<   `document_id` int(11) default NULL 

>   `document_id` int(11) default NULL, 
>   PRIMARY KEY  (`tempfilename`), 
>   KEY `userid` (`userid`), 
>   KEY `document_id` (`document_id`), 
>   CONSTRAINT `uploaded_files_ibfk_1` FOREIGN KEY (`userid`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `uploaded_files_ibfk_2` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1360c1483
ALTER TABLE `user_history` MODIFY COLUMN 
<   CONSTRAINT `user_history_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE 

>   CONSTRAINT `user_history_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1362a1486
ALTER TABLE `user_history` ADD COLUMN 
****1391c1515
ALTER TABLE `users` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 

>   PRIMARY KEY  (`id`);
****1393,1395c1517
ALTER TABLE `users` MODIFY COLUMN 
<   KEY `authentication_source` (`authentication_source_id`), 
<   KEY `authentication_details_b1` (`authentication_details_b1`), 
<   KEY `authentication_details_b2` (`authentication_details_b2`), 

>   KEY `authentication_source_id` (`authentication_source_id`);
****1398c1520
ALTER TABLE `users` MODIFY COLUMN 
<   CONSTRAINT `users_ibfk_1` FOREIGN KEY (`authentication_source_id`) REFERENCES `authentication_sources` (`id`) ON DELETE SET NULL 

>   CONSTRAINT `users_ibfk_1` FOREIGN KEY (`authentication_source_id`) REFERENCES `authentication_sources` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1409,1413c1531,1535
ALTER TABLE `users_groups_link` MODIFY COLUMN 
<   UNIQUE KEY `id` (`id`), 
<   KEY `fk_user_id` (`user_id`), 
<   KEY `fk_group_id` (`group_id`), 
<   CONSTRAINT `users_groups_link_ibfk_1` FOREIGN KEY (`group_id`) REFERENCES `groups_lookup` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `users_groups_link_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE 

>   PRIMARY KEY  (`id`), 
>   KEY `user_id` (`user_id`), 
>   KEY `group_id` (`group_id`), 
>   CONSTRAINT `users_groups_link_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `users_groups_link_ibfk_2` FOREIGN KEY (`group_id`) REFERENCES `groups_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1423,1424c1545
ALTER TABLE `workflow_actions` MODIFY COLUMN 
<   KEY `workflow_id` (`workflow_id`), 
<   KEY `action_name` (`action_name`) 

>   PRIMARY KEY  (`workflow_id`)
****1437c1558,1561
ALTER TABLE `workflow_documents` MODIFY COLUMN 
<   KEY `state_id` (`state_id`) 

>   KEY `state_id` (`state_id`), 
>   CONSTRAINT `workflow_documents_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `workflow_documents_ibfk_2` FOREIGN KEY (`workflow_id`) REFERENCES `workflows` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `workflow_documents_ibfk_3` FOREIGN KEY (`state_id`) REFERENCES `workflow_states` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1448c1572
ALTER TABLE `workflow_state_actions` MODIFY COLUMN 
<   KEY `action_name` (`action_name`) 

>   CONSTRAINT `workflow_state_actions_ibfk_1` FOREIGN KEY (`state_id`) REFERENCES `workflow_states` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1459c1583
ALTER TABLE `workflow_state_disabled_actions` MODIFY COLUMN 
<   KEY `action_name` (`action_name`) 

>   CONSTRAINT `workflow_state_disabled_actions_ibfk_1` FOREIGN KEY (`state_id`) REFERENCES `workflow_states` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1475,1476c1599,1601
ALTER TABLE `workflow_state_permission_assignments` MODIFY COLUMN 
<   CONSTRAINT `workflow_state_permission_assignments_ibfk_7` FOREIGN KEY (`permission_id`) REFERENCES `permissions` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `workflow_state_permission_assignments_ibfk_8` FOREIGN KEY (`permission_descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE 

>   CONSTRAINT `workflow_state_permission_assignments_ibfk_1` FOREIGN KEY (`permission_id`) REFERENCES `permissions` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `workflow_state_permission_assignments_ibfk_2` FOREIGN KEY (`permission_descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `workflow_state_permission_assignments_ibfk_3` FOREIGN KEY (`workflow_state_id`) REFERENCES `workflow_states` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1485c1610,1614
ALTER TABLE `workflow_state_transitions` MODIFY COLUMN 
<   `transition_id` int(11) NOT NULL default '0' 

>   `transition_id` int(11) NOT NULL default '0', 
>   PRIMARY KEY  (`state_id`,`transition_id`), 
>   KEY `transition_id` (`transition_id`), 
>   CONSTRAINT `workflow_state_transitions_ibfk_2` FOREIGN KEY (`transition_id`) REFERENCES `workflow_transitions` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `workflow_state_transitions_ibfk_1` FOREIGN KEY (`state_id`) REFERENCES `workflow_states` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1504,1505c1633,1634
ALTER TABLE `workflow_states` MODIFY COLUMN 
<   CONSTRAINT `workflow_states_ibfk_1` FOREIGN KEY (`workflow_id`) REFERENCES `workflows` (`id`), 
<   CONSTRAINT `workflow_states_ibfk_2` FOREIGN KEY (`inform_descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE SET NULL 

>   CONSTRAINT `workflow_states_ibfk_1` FOREIGN KEY (`workflow_id`) REFERENCES `workflows` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `workflow_states_ibfk_2` FOREIGN KEY (`inform_descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1523,1525c1652
ALTER TABLE `workflow_transitions` MODIFY COLUMN 
<   UNIQUE KEY `workflow_id_2` (`workflow_id`,`name`), 
<   KEY `workflow_id` (`workflow_id`), 
<   KEY `name` (`name`), 

>   UNIQUE KEY `workflow_id_name` (`workflow_id`,`name`);
****1527,1528c1654
ALTER TABLE `workflow_transitions` MODIFY COLUMN 
<   KEY `guard_permission_id` (`guard_permission_id`), 
<   KEY `guard_condition` (`guard_condition_id`), 

>   KEY `guard_condition_id` (`guard_condition_id`);
****1531,1536c1657,1664
ALTER TABLE `workflow_transitions` MODIFY COLUMN 
<   CONSTRAINT `workflow_transitions_ibfk_45` FOREIGN KEY (`workflow_id`) REFERENCES `workflows` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `workflow_transitions_ibfk_46` FOREIGN KEY (`target_state_id`) REFERENCES `workflow_states` (`id`) ON DELETE CASCADE, 
<   CONSTRAINT `workflow_transitions_ibfk_47` FOREIGN KEY (`guard_permission_id`) REFERENCES `permissions` (`id`) ON DELETE SET NULL, 
<   CONSTRAINT `workflow_transitions_ibfk_48` FOREIGN KEY (`guard_group_id`) REFERENCES `groups_lookup` (`id`) ON DELETE SET NULL, 
<   CONSTRAINT `workflow_transitions_ibfk_49` FOREIGN KEY (`guard_role_id`) REFERENCES `roles` (`id`) ON DELETE SET NULL, 
<   CONSTRAINT `workflow_transitions_ibfk_50` FOREIGN KEY (`guard_condition_id`) REFERENCES `saved_searches` (`id`) ON DELETE SET NULL 

>   KEY `name` (`name`), 
>   KEY `guard_permission_id` (`guard_permission_id`), 
>   CONSTRAINT `workflow_transitions_ibfk_1` FOREIGN KEY (`workflow_id`) REFERENCES `workflows` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `workflow_transitions_ibfk_2` FOREIGN KEY (`target_state_id`) REFERENCES `workflow_states` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `workflow_transitions_ibfk_3` FOREIGN KEY (`guard_permission_id`) REFERENCES `permissions` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `workflow_transitions_ibfk_4` FOREIGN KEY (`guard_condition_id`) REFERENCES `saved_searches` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `workflow_transitions_ibfk_5` FOREIGN KEY (`guard_group_id`) REFERENCES `groups_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, 
>   CONSTRAINT `workflow_transitions_ibfk_6` FOREIGN KEY (`guard_role_id`) REFERENCES `roles` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1550c1678,1679
ALTER TABLE `workflow_trigger_instances` MODIFY COLUMN 
<   KEY `namespace` (`namespace`) 

>   KEY `namespace` (`namespace`), 
>   CONSTRAINT `workflow_trigger_instances_ibfk_1` FOREIGN KEY (`workflow_transition_id`) REFERENCES `workflow_transitions` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****1566c1695
ALTER TABLE `workflows` MODIFY COLUMN 
<   CONSTRAINT `workflows_ibfk_1` FOREIGN KEY (`start_state_id`) REFERENCES `workflow_states` (`id`) 

>   CONSTRAINT `workflows_ibfk_1` FOREIGN KEY (`start_state_id`) REFERENCES `workflow_states` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
****2097c2226,2228