ALTER TABLE `discussion_threads` DROP KEY `id`;
ALTER TABLE `discussion_threads` ADD PRIMARY KEY  (`id`), ADD KEY `document_id` (`document_id`), ADD KEY `first_comment_id` (`first_comment_id`), ADD KEY `last_comment_id` (`last_comment_id`), ADD KEY `creator_id` (`creator_id`), ADD CONSTRAINT `discussion_threads_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `discussion_threads_ibfk_2` FOREIGN KEY (`first_comment_id`) REFERENCES `discussion_comments` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `discussion_threads_ibfk_3` FOREIGN KEY (`last_comment_id`) REFERENCES `discussion_comments` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `discussion_threads_ibfk_4` FOREIGN KEY (`creator_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `document_archiving_link` DROP KEY `id`;
ALTER TABLE `document_archiving_link` ADD PRIMARY KEY  (`id`), ADD KEY `document_id` (`document_id`), ADD KEY `archiving_settings_id` (`archiving_settings_id`), ADD CONSTRAINT `document_archiving_link_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `document_archiving_link_ibfk_2` FOREIGN KEY (`archiving_settings_id`) REFERENCES `archiving_settings` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `document_content_version`;
ALTER TABLE `document_content_version` ADD `mime_id` int(11) default '9';
ALTER TABLE `document_content_version` DROP KEY `id`;
ALTER TABLE `document_content_version` ADD PRIMARY KEY  (`id`), ADD KEY `document_id` (`document_id`), ADD KEY `mime_id` (`mime_id`);
ALTER TABLE `document_content_version` DROP KEY `document_id`;
ALTER TABLE `document_content_version` ADD CONSTRAINT `document_content_version_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `document_content_version_ibfk_2` FOREIGN KEY (`mime_id`) REFERENCES `mime_types` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `document_fields` DROP KEY `id`;
ALTER TABLE `document_fields` ADD PRIMARY KEY  (`id`);
ALTER TABLE `document_fields` DROP FOREIGN KEY `document_fields_ibfk_1`;
ALTER TABLE `document_fields` ADD CONSTRAINT `document_fields_ibfk_1` FOREIGN KEY (`parent_fieldset`) REFERENCES `fieldsets` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `document_fields_link` DROP KEY `id`;
ALTER TABLE `document_fields_link` ADD PRIMARY KEY  (`id`);
ALTER TABLE `document_fields_link` DROP FOREIGN KEY `document_fields_link_ibfk_2`;
ALTER TABLE `document_fields_link` ADD CONSTRAINT `document_fields_link_ibfk_1` FOREIGN KEY (`document_field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `document_fields_link_ibfk_2` FOREIGN KEY (`metadata_version_id`) REFERENCES `document_metadata_version` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `document_link` DROP KEY `id`;
ALTER TABLE `document_link` ADD PRIMARY KEY  (`id`), ADD KEY `parent_document_id` (`parent_document_id`), ADD KEY `child_document_id` (`child_document_id`), ADD KEY `link_type_id` (`link_type_id`), ADD CONSTRAINT `document_link_ibfk_1` FOREIGN KEY (`parent_document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `document_link_ibfk_2` FOREIGN KEY (`child_document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `document_link_ibfk_3` FOREIGN KEY (`link_type_id`) REFERENCES `document_link_types` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `document_link_types` DROP KEY `id`;
ALTER TABLE `document_link_types` ADD PRIMARY KEY  (`id`);
ALTER TABLE `document_metadata_version` DROP KEY `id`,DROP KEY `fk_document_type_id`,DROP KEY `fk_status_id`;
ALTER TABLE `document_metadata_version` ADD PRIMARY KEY  (`id`), ADD KEY `document_type_id` (`document_type_id`), ADD KEY `status_id` (`status_id`);
ALTER TABLE `document_metadata_version`;
ALTER TABLE `document_metadata_version` DROP FOREIGN KEY `document_metadata_version_ibfk_4`,DROP FOREIGN KEY `document_metadata_version_ibfk_5`,DROP FOREIGN KEY `document_metadata_version_ibfk_6`,DROP FOREIGN KEY `document_metadata_version_ibfk_7`,DROP FOREIGN KEY `document_metadata_version_ibfk_8`,DROP FOREIGN KEY `document_metadata_version_ibfk_9`;
ALTER TABLE `document_metadata_version` ADD KEY `version_created` (`version_created`), ADD CONSTRAINT `document_metadata_version_ibfk_1` FOREIGN KEY (`document_type_id`) REFERENCES `document_types_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `document_metadata_version_ibfk_2` FOREIGN KEY (`status_id`) REFERENCES `status_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `document_metadata_version_ibfk_3` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `document_metadata_version_ibfk_4` FOREIGN KEY (`version_creator_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `document_metadata_version_ibfk_5` FOREIGN KEY (`content_version_id`) REFERENCES `document_content_version` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `document_metadata_version_ibfk_6` FOREIGN KEY (`workflow_id`) REFERENCES `workflows` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `document_metadata_version_ibfk_7` FOREIGN KEY (`workflow_state_id`) REFERENCES `workflow_states` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `document_role_allocations` DROP KEY `id`,DROP KEY `document_id`;
ALTER TABLE `document_role_allocations` ADD PRIMARY KEY  (`id`), ADD KEY `role_id` (`role_id`), ADD KEY `permission_descriptor_id` (`permission_descriptor_id`), ADD KEY `document_id_role_id` (`document_id`,`role_id`), ADD CONSTRAINT `document_role_allocations_ibfk_1` FOREIGN KEY (`role_id`) REFERENCES `roles` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `document_role_allocations_ibfk_2` FOREIGN KEY (`permission_descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `document_searchable_text` DROP KEY `document_text_document_id_indx`;
ALTER TABLE `document_searchable_text` ADD KEY `document_id` (`document_id`);
ALTER TABLE `document_subscriptions` DROP KEY `id`;
ALTER TABLE `document_subscriptions` ADD PRIMARY KEY  (`id`), ADD KEY `user_id` (`user_id`), ADD KEY `document_id` (`document_id`), ADD CONSTRAINT `document_subscriptions_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `document_subscriptions_ibfk_2` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `document_tags` DROP KEY `fk_document_tags_tag_id`,DROP FOREIGN KEY `fk_document_tags_document_id`,DROP FOREIGN KEY `fk_document_tags_tag_id`;
ALTER TABLE `document_tags` ADD KEY `tag_id` (`tag_id`), ADD CONSTRAINT `document_tags_ibfk_2` FOREIGN KEY (`tag_id`) REFERENCES `tag_words` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `document_tags_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `document_text`;
ALTER TABLE `document_text` ADD `document_id` int(11) NOT NULL default '0';
ALTER TABLE `document_text` DROP KEY `document_text_document_id_indx`;
ALTER TABLE `document_text` ADD PRIMARY KEY  (`document_id`);
ALTER TABLE `document_transaction_text`;
ALTER TABLE `document_transaction_text` ADD `document_id` int(11) NOT NULL default '0';
ALTER TABLE `document_transaction_text` DROP KEY `document_text_document_id_indx`;
ALTER TABLE `document_transaction_text` ADD PRIMARY KEY  (`document_id`);
ALTER TABLE `document_transaction_types_lookup` DROP KEY `id`,DROP KEY `namespace`;
ALTER TABLE `document_transaction_types_lookup` ADD PRIMARY KEY  (`id`), ADD UNIQUE KEY `namespace` (`namespace`);
ALTER TABLE `document_transactions`;
ALTER TABLE `document_transactions` ADD `document_id` int(11) default NULL;
ALTER TABLE `document_transactions`;
ALTER TABLE `document_transactions` ADD `user_id` int(11) default NULL;
ALTER TABLE `document_transactions` DROP KEY `id`,DROP KEY `fk_document_id`,DROP KEY `fk_user_id`,DROP KEY `session_id`;
ALTER TABLE `document_transactions` ADD PRIMARY KEY  (`id`), ADD KEY `document_id` (`document_id`), ADD KEY `user_id` (`user_id`), ADD KEY `session_id` (`session_id`), ADD CONSTRAINT `document_transactions_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE SET NULL ON UPDATE SET NULL, ADD CONSTRAINT `document_transactions_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE SET NULL ON UPDATE SET NULL;
ALTER TABLE `document_type_fields_link` DROP KEY `id`;
ALTER TABLE `document_type_fields_link` ADD PRIMARY KEY  (`id`), ADD KEY `document_type_id` (`document_type_id`), ADD KEY `field_id` (`field_id`), ADD CONSTRAINT `document_type_fields_link_ibfk_1` FOREIGN KEY (`document_type_id`) REFERENCES `document_types_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `document_type_fields_link_ibfk_2` FOREIGN KEY (`field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `document_type_fieldsets_link` DROP KEY `id`;
ALTER TABLE `document_type_fieldsets_link` ADD PRIMARY KEY  (`id`);
ALTER TABLE `document_type_fieldsets_link` DROP FOREIGN KEY `document_type_fieldsets_link_ibfk_1`,DROP FOREIGN KEY `document_type_fieldsets_link_ibfk_2`;
ALTER TABLE `document_type_fieldsets_link` ADD CONSTRAINT `document_type_fieldsets_link_ibfk_1` FOREIGN KEY (`document_type_id`) REFERENCES `document_types_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `document_type_fieldsets_link_ibfk_2` FOREIGN KEY (`fieldset_id`) REFERENCES `fieldsets` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `document_types_lookup` DROP KEY `id`,DROP KEY `name`,DROP KEY `disabled`;
ALTER TABLE `document_types_lookup` ADD PRIMARY KEY  (`id`), ADD KEY `name` (`name`);
ALTER TABLE `documents`;
ALTER TABLE `documents` ADD `creator_id` int(11) default NULL;
ALTER TABLE `documents`;
ALTER TABLE `documents` ADD `modified_user_id` int(11) default NULL;
ALTER TABLE `documents`;
ALTER TABLE `documents` ADD `owner_id` int(11) default NULL;
ALTER TABLE `documents` DROP KEY `id`,DROP KEY `fk_creator_id`,DROP KEY `fk_folder_id`,DROP KEY `fk_checked_out_user_id`,DROP KEY `fk_status_id`,DROP KEY `created`;
ALTER TABLE `documents` ADD PRIMARY KEY  (`id`), ADD KEY `creator_id` (`creator_id`), ADD KEY `folder_id` (`folder_id`), ADD KEY `checked_out_user_id` (`checked_out_user_id`), ADD KEY `status_id` (`status_id`);
ALTER TABLE `documents` DROP KEY `metadata_version_id`;
ALTER TABLE `documents` ADD KEY `metadata_version_id` (`metadata_version_id`), ADD KEY `created` (`created`), ADD CONSTRAINT `documents_ibfk_1` FOREIGN KEY (`creator_id`) REFERENCES `users` (`id`) ON DELETE SET NULL ON UPDATE SET NULL, ADD CONSTRAINT `documents_ibfk_2` FOREIGN KEY (`folder_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `documents_ibfk_3` FOREIGN KEY (`checked_out_user_id`) REFERENCES `users` (`id`) ON DELETE SET NULL ON UPDATE SET NULL, ADD CONSTRAINT `documents_ibfk_4` FOREIGN KEY (`status_id`) REFERENCES `status_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `documents_ibfk_5` FOREIGN KEY (`permission_object_id`) REFERENCES `permission_objects` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `documents_ibfk_6` FOREIGN KEY (`permission_lookup_id`) REFERENCES `permission_lookups` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `documents_ibfk_7` FOREIGN KEY (`modified_user_id`) REFERENCES `users` (`id`) ON DELETE SET NULL ON UPDATE SET NULL, ADD CONSTRAINT `documents_ibfk_8` FOREIGN KEY (`metadata_version_id`) REFERENCES `document_metadata_version` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `download_files`;
ALTER TABLE `download_files` ADD `document_id` int(11) NOT NULL;
ALTER TABLE `download_files` DROP KEY (`document_id`,`session`);
ALTER TABLE `download_files` ADD PRIMARY KEY  (`document_id`,`session`), ADD CONSTRAINT `download_files_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `field_behaviour_options`;
ALTER TABLE `field_behaviour_options` DROP FOREIGN KEY `field_behaviour_options_ibfk_1`,DROP FOREIGN KEY `field_behaviour_options_ibfk_2`,DROP FOREIGN KEY `field_behaviour_options_ibfk_3`;
ALTER TABLE `field_behaviour_options` ADD KEY `behaviour_id_field_id` (`behaviour_id`,`field_id`), ADD CONSTRAINT `field_behaviour_options_ibfk_1` FOREIGN KEY (`behaviour_id`) REFERENCES `field_behaviours` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `field_behaviour_options_ibfk_2` FOREIGN KEY (`field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `field_behaviour_options_ibfk_3` FOREIGN KEY (`instance_id`) REFERENCES `field_value_instances` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `field_behaviours` DROP FOREIGN KEY `field_behaviours_ibfk_1`;
ALTER TABLE `field_behaviours` ADD CONSTRAINT `field_behaviours_ibfk_1` FOREIGN KEY (`field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `field_orders` DROP KEY `child_field`,DROP KEY `parent_field`;
ALTER TABLE `field_orders` ADD UNIQUE KEY `child_field_id` (`child_field_id`), ADD KEY `parent_field_id` (`parent_field_id`);
ALTER TABLE `field_orders` DROP FOREIGN KEY `field_orders_ibfk_1`,DROP FOREIGN KEY `field_orders_ibfk_2`,DROP FOREIGN KEY `field_orders_ibfk_3`;
ALTER TABLE `field_orders` ADD CONSTRAINT `field_orders_ibfk_1` FOREIGN KEY (`child_field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `field_orders_ibfk_2` FOREIGN KEY (`parent_field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `field_orders_ibfk_3` FOREIGN KEY (`fieldset_id`) REFERENCES `fieldsets` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `field_value_instances`;
ALTER TABLE `field_value_instances` DROP FOREIGN KEY `field_value_instances_ibfk_1`,DROP FOREIGN KEY `field_value_instances_ibfk_2`,DROP FOREIGN KEY `field_value_instances_ibfk_3`;
ALTER TABLE `field_value_instances` ADD KEY `field_id` (`field_id`), ADD CONSTRAINT `field_value_instances_ibfk_1` FOREIGN KEY (`field_value_id`) REFERENCES `metadata_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `field_value_instances_ibfk_2` FOREIGN KEY (`behaviour_id`) REFERENCES `field_behaviours` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `field_value_instances_ibfk_3` FOREIGN KEY (`field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `fieldsets` DROP KEY `id`;
ALTER TABLE `fieldsets` ADD PRIMARY KEY  (`id`), ADD KEY `master_field` (`master_field`);
DROP KEY `master_field`,DROP FOREIGN KEY `fieldsets_ibfk_1`;
ALTER TABLE  ADD CONSTRAINT `fieldsets_ibfk_1` FOREIGN KEY (`master_field`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE ,ADD > ) ENGINE=InnoDB DEFAULT CHARSET=utf8; ,ADD > ,ADD > -- ,ADD > -- Table structure for table `folder_descendants` ,ADD > -- ,ADD > ,ADD > CREATE TABLE `folder_descendants` ( ,ADD `parent_id` int(11) NOT NULL, ADD `folder_id` int(11) NOT NULL, ADD KEY `parent_id` (`parent_id`), ADD KEY `folder_id` (`folder_id`), ADD CONSTRAINT `folder_descendants_ibfk_2` FOREIGN KEY (`folder_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `folder_descendants_ibfk_1` FOREIGN KEY (`parent_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `folder_doctypes_link` DROP KEY `id`,DROP KEY `fk_folder_id`,DROP KEY `fk_document_type_id`;
ALTER TABLE `folder_doctypes_link` ADD PRIMARY KEY  (`id`), ADD KEY `folder_id` (`folder_id`), ADD KEY `document_type_id` (`document_type_id`), ADD CONSTRAINT `folder_doctypes_link_ibfk_1` FOREIGN KEY (`folder_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `folder_doctypes_link_ibfk_2` FOREIGN KEY (`document_type_id`) REFERENCES `document_types_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `folder_searchable_text`;
ALTER TABLE `folder_subscriptions` DROP KEY `id`;
ALTER TABLE `folder_subscriptions` ADD PRIMARY KEY  (`id`), ADD KEY `user_id` (`user_id`), ADD KEY `folder_id` (`folder_id`), ADD CONSTRAINT `folder_subscriptions_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `folder_subscriptions_ibfk_2` FOREIGN KEY (`folder_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `folder_transactions`;
ALTER TABLE `folder_transactions` ADD `folder_id` int(11) default NULL, ADD `user_id` int(11) default NULL;
ALTER TABLE `folder_transactions` DROP KEY `id`;
ALTER TABLE `folder_transactions` ADD PRIMARY KEY  (`id`);
ALTER TABLE `folder_transactions` DROP FOREIGN KEY `folder_transactions_ibfk_1`,DROP FOREIGN KEY `folder_transactions_ibfk_2`;
ALTER TABLE `folder_transactions` ADD CONSTRAINT `folder_transactions_ibfk_1` FOREIGN KEY (`folder_id`) REFERENCES `folders` (`id`) ON DELETE SET NULL ON UPDATE SET NULL, ADD CONSTRAINT `folder_transactions_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE SET NULL ON UPDATE SET NULL;
ALTER TABLE `folder_workflow_map` DROP KEY `folder_id`;
ALTER TABLE `folder_workflow_map` ADD KEY `workflow_id` (`workflow_id`), ADD CONSTRAINT `folder_workflow_map_ibfk_1` FOREIGN KEY (`folder_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `folder_workflow_map_ibfk_2` FOREIGN KEY (`workflow_id`) REFERENCES `workflows` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `folders` DROP KEY `id`,DROP KEY `fk_parent_id`,DROP KEY `fk_creator_id`;
ALTER TABLE `folders` ADD `owner_id` int(11) default NULL, ADD PRIMARY KEY  (`id`), ADD KEY `creator_id` (`creator_id`);
ALTER TABLE `folders` DROP KEY `permission_lookup_id`;
ALTER TABLE `folders` ADD KEY `permission_lookup_id` (`permission_lookup_id`), ADD KEY `parent_id_name` (`parent_id`,`name`), ADD CONSTRAINT `folders_ibfk_1` FOREIGN KEY (`creator_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `folders_ibfk_2` FOREIGN KEY (`permission_object_id`) REFERENCES `permission_objects` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `folders_ibfk_3` FOREIGN KEY (`permission_lookup_id`) REFERENCES `permission_lookups` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `folders_ibfk_4` FOREIGN KEY (`parent_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `folders_users_roles_link` DROP KEY `id`;
ALTER TABLE `folders_users_roles_link` ADD PRIMARY KEY  (`id`), ADD KEY `user_id` (`user_id`), ADD KEY `document_id` (`document_id`), ADD CONSTRAINT `folders_users_roles_link_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `folders_users_roles_link_ibfk_2` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `groups_groups_link` DROP KEY `groups_groups_link_ibfk_1`,DROP KEY `groups_groups_link_ibfk_2`,DROP FOREIGN KEY `groups_groups_link_ibfk_1`,DROP FOREIGN KEY `groups_groups_link_ibfk_2`;
ALTER TABLE `groups_groups_link` ADD KEY `parent_group_id` (`parent_group_id`), ADD KEY `member_group_id` (`member_group_id`), ADD CONSTRAINT `groups_groups_link_ibfk_1` FOREIGN KEY (`parent_group_id`) REFERENCES `groups_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `groups_groups_link_ibfk_2` FOREIGN KEY (`member_group_id`) REFERENCES `groups_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `groups_lookup` DROP KEY `id`;
ALTER TABLE `groups_lookup` ADD PRIMARY KEY  (`id`);
ALTER TABLE `groups_lookup` DROP KEY `authentication_details_s1`,DROP KEY `authentication_source_id`,DROP FOREIGN KEY `groups_lookup_ibfk_1`;
ALTER TABLE `groups_lookup` ADD KEY `authentication_source_id_authentication_details_s1` (`authentication_source_id`,`authentication_details_s1`), ADD CONSTRAINT `groups_lookup_ibfk_1` FOREIGN KEY (`unit_id`) REFERENCES `units_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `help` DROP KEY `id`;
ALTER TABLE `help` ADD PRIMARY KEY  (`id`);
ALTER TABLE `index_files`;
ALTER TABLE `index_files` ADD `document_id` int(11) NOT NULL, ADD `user_id` int(11) NOT NULL;
ALTER TABLE `index_files` DROP KEY (`document_id`);
ALTER TABLE `index_files` ADD PRIMARY KEY  (`document_id`), ADD KEY `user_id` (`user_id`), ADD CONSTRAINT `index_files_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `index_files_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `links` DROP KEY `id`;
ALTER TABLE `links` ADD PRIMARY KEY  (`id`);
ALTER TABLE `metadata_lookup` DROP KEY `id`;
ALTER TABLE `metadata_lookup` ADD PRIMARY KEY  (`id`), ADD KEY `document_field_id` (`document_field_id`);
ALTER TABLE `metadata_lookup` DROP KEY `is_stuck`;
ALTER TABLE `metadata_lookup` ADD CONSTRAINT `metadata_lookup_ibfk_1` FOREIGN KEY (`document_field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `metadata_lookup_tree` DROP KEY `id`;
ALTER TABLE `metadata_lookup_tree` ADD PRIMARY KEY  (`id`), ADD KEY `document_field_id` (`document_field_id`);
ALTER TABLE `metadata_lookup_tree` DROP KEY `document_field_id`;
ALTER TABLE `metadata_lookup_tree` ADD CONSTRAINT `metadata_lookup_tree_ibfk_1` FOREIGN KEY (`document_field_id`) REFERENCES `document_fields` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `mime_types` DROP KEY `id`;
ALTER TABLE `mime_types` ADD PRIMARY KEY  (`id`), ADD KEY `mime_document_id` (`mime_document_id`), ADD KEY `filetypes` (`filetypes`), ADD KEY `mimetypes` (`mimetypes`), ADD CONSTRAINT `mime_types_ibfk_1` FOREIGN KEY (`mime_document_id`) REFERENCES `mime_documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `news` DROP KEY `id`;
ALTER TABLE `news` ADD PRIMARY KEY  (`id`), ADD KEY `image_mime_type_id` (`image_mime_type_id`), ADD CONSTRAINT `news_ibfk_1` FOREIGN KEY (`image_mime_type_id`) REFERENCES `mime_types` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `notifications` DROP KEY `id`,DROP KEY `type`,DROP KEY `user_id`;
ALTER TABLE `notifications` ADD PRIMARY KEY  (`id`), ADD KEY `user_id` (`user_id`), ADD KEY `data_int_1` (`data_int_1`), ADD CONSTRAINT `notifications_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `organisations_lookup` DROP KEY `id`;
ALTER TABLE `organisations_lookup` ADD PRIMARY KEY  (`id`);
ALTER TABLE `permission_assignments` DROP KEY `permission_and_object`;
ALTER TABLE `permission_assignments` ADD UNIQUE KEY `permission_object_id_permission_id` (`permission_object_id`,`permission_id`);
ALTER TABLE `permission_assignments`;
ALTER TABLE `permission_assignments` DROP FOREIGN KEY `permission_assignments_ibfk_1`,DROP FOREIGN KEY `permission_assignments_ibfk_2`,DROP FOREIGN KEY `permission_assignments_ibfk_3`;
ALTER TABLE `permission_assignments` ADD CONSTRAINT `permission_assignments_ibfk_1` FOREIGN KEY (`permission_id`) REFERENCES `permissions` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `permission_assignments_ibfk_2` FOREIGN KEY (`permission_object_id`) REFERENCES `permission_objects` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `permission_assignments_ibfk_3` FOREIGN KEY (`permission_descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `permission_descriptor_groups` DROP KEY `descriptor_id`,DROP KEY `descriptor_id_2`;
ALTER TABLE `permission_descriptor_groups` ADD PRIMARY KEY  (`descriptor_id`,`group_id`);
ALTER TABLE `permission_descriptor_groups` DROP FOREIGN KEY `permission_descriptor_groups_ibfk_1`,DROP FOREIGN KEY `permission_descriptor_groups_ibfk_2`;
ALTER TABLE `permission_descriptor_groups` ADD CONSTRAINT `permission_descriptor_groups_ibfk_1` FOREIGN KEY (`descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `permission_descriptor_groups_ibfk_2` FOREIGN KEY (`group_id`) REFERENCES `groups_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `permission_descriptor_roles` DROP KEY `descriptor_id`,DROP KEY `descriptor_id_2`;
ALTER TABLE `permission_descriptor_roles` ADD PRIMARY KEY  (`descriptor_id`,`role_id`);
ALTER TABLE `permission_descriptor_roles` DROP FOREIGN KEY `permission_descriptor_roles_ibfk_1`,DROP FOREIGN KEY `permission_descriptor_roles_ibfk_2`;
ALTER TABLE `permission_descriptor_roles` ADD CONSTRAINT `permission_descriptor_roles_ibfk_1` FOREIGN KEY (`descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `permission_descriptor_roles_ibfk_2` FOREIGN KEY (`role_id`) REFERENCES `roles` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `permission_descriptor_users` DROP KEY `descriptor_id`,DROP KEY `descriptor_id_2`;
ALTER TABLE `permission_descriptor_users` ADD PRIMARY KEY  (`descriptor_id`,`user_id`);
ALTER TABLE `permission_descriptor_users` DROP FOREIGN KEY `permission_descriptor_users_ibfk_1`,DROP FOREIGN KEY `permission_descriptor_users_ibfk_2`;
ALTER TABLE `permission_descriptor_users` ADD CONSTRAINT `permission_descriptor_users_ibfk_1` FOREIGN KEY (`descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `permission_descriptor_users_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `permission_descriptors` DROP KEY `descriptor_2`,DROP KEY `descriptor`;
ALTER TABLE `permission_descriptors` ADD UNIQUE KEY `descriptor` (`descriptor`);
ALTER TABLE `permission_dynamic_assignments` DROP KEY `dynamic_conditiond_id`;
ALTER TABLE `permission_dynamic_assignments` ADD KEY `dynamic_condition_id` (`dynamic_condition_id`);
ALTER TABLE `permission_dynamic_assignments` DROP FOREIGN KEY `permission_dynamic_assignments_ibfk_2`,DROP FOREIGN KEY `permission_dynamic_assignments_ibfk_3`;
ALTER TABLE `permission_dynamic_assignments` ADD CONSTRAINT `permission_dynamic_assignments_ibfk_2` FOREIGN KEY (`permission_id`) REFERENCES `permissions` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `permission_dynamic_assignments_ibfk_1` FOREIGN KEY (`dynamic_condition_id`) REFERENCES `permission_dynamic_conditions` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `permission_dynamic_conditions` DROP FOREIGN KEY `permission_dynamic_conditions_ibfk_1`,DROP FOREIGN KEY `permission_dynamic_conditions_ibfk_2`,DROP FOREIGN KEY `permission_dynamic_conditions_ibfk_3`;
ALTER TABLE `permission_dynamic_conditions` ADD CONSTRAINT `permission_dynamic_conditions_ibfk_1` FOREIGN KEY (`permission_object_id`) REFERENCES `permission_objects` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `permission_dynamic_conditions_ibfk_2` FOREIGN KEY (`group_id`) REFERENCES `groups_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `permission_dynamic_conditions_ibfk_3` FOREIGN KEY (`condition_id`) REFERENCES `saved_searches` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `permission_lookup_assignments` DROP KEY `permission_and_lookup`;
ALTER TABLE `permission_lookup_assignments` ADD UNIQUE KEY `permission_lookup_id_permission_id` (`permission_lookup_id`,`permission_id`);
ALTER TABLE `permission_lookup_assignments`;
ALTER TABLE `permission_lookup_assignments` DROP FOREIGN KEY `permission_lookup_assignments_ibfk_1`,DROP FOREIGN KEY `permission_lookup_assignments_ibfk_2`,DROP FOREIGN KEY `permission_lookup_assignments_ibfk_3`;
ALTER TABLE `permission_lookup_assignments` ADD CONSTRAINT `permission_lookup_assignments_ibfk_1` FOREIGN KEY (`permission_id`) REFERENCES `permissions` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `permission_lookup_assignments_ibfk_2` FOREIGN KEY (`permission_lookup_id`) REFERENCES `permission_lookups` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `permission_lookup_assignments_ibfk_3` FOREIGN KEY (`permission_descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `plugin_rss` DROP KEY (`id`);
ALTER TABLE `plugin_rss` ADD PRIMARY KEY  (`id`), ADD KEY `user_id` (`user_id`), ADD CONSTRAINT `plugin_rss_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE ,ADD > ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
ALTER TABLE `plugins` DROP KEY `name`;
ALTER TABLE `plugins` ADD UNIQUE KEY `namespace` (`namespace`), ADD KEY `disabled` (`disabled`);
ALTER TABLE `role_allocations` DROP KEY `id`,DROP KEY `folder_id`;
ALTER TABLE `role_allocations` ADD PRIMARY KEY  (`id`), ADD KEY `folder_id` (`folder_id`), ADD KEY `role_id` (`role_id`), ADD KEY `permission_descriptor_id` (`permission_descriptor_id`), ADD CONSTRAINT `role_allocations_ibfk_1` FOREIGN KEY (`folder_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `role_allocations_ibfk_2` FOREIGN KEY (`role_id`) REFERENCES `roles` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `role_allocations_ibfk_3` FOREIGN KEY (`permission_descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `roles` DROP KEY `id`;
ALTER TABLE `roles` ADD PRIMARY KEY  (`id`);
ALTER TABLE `saved_searches` DROP KEY `namespace`,DROP KEY `is_condition`,DROP KEY `is_complete`;
ALTER TABLE `saved_searches` ADD UNIQUE KEY `namespace` (`namespace`);
ALTER TABLE `scheduler_tasks`;
ALTER TABLE `scheduler_tasks` ADD `run_time` datetime default NULL, ADD `previous_run_time` datetime default NULL, ADD `run_duration` float default NULL, ADD PRIMARY KEY  (`id`);
ALTER TABLE `search_document_user_link` DROP KEY `fk_user_id`,DROP KEY `fk_document_ids`;
ALTER TABLE `search_document_user_link` ADD KEY `document_id` (`document_id`), ADD KEY `user_id` (`user_id`), ADD CONSTRAINT `search_document_user_link_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `search_document_user_link_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `search_saved` DROP KEY (`id`);
ALTER TABLE `search_saved` ADD PRIMARY KEY  (`id`), ADD KEY `user_id` (`user_id`), ADD CONSTRAINT `search_saved_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `search_saved_events`;
ALTER TABLE `search_saved_events` ADD `document_id` int(11) NOT NULL, ADD PRIMARY KEY  (`document_id`), ADD CONSTRAINT `search_saved_events_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `status_lookup` DROP KEY `id`;
ALTER TABLE `status_lookup` ADD PRIMARY KEY  (`id`);
ALTER TABLE `system_settings` DROP KEY `id`;
ALTER TABLE `system_settings` ADD PRIMARY KEY  (`id`), ADD UNIQUE KEY `name` (`name`);
ALTER TABLE `time_period` DROP KEY `id`;
ALTER TABLE `time_period` ADD PRIMARY KEY  (`id`), ADD KEY `time_unit_id` (`time_unit_id`), ADD CONSTRAINT `time_period_ibfk_1` FOREIGN KEY (`time_unit_id`) REFERENCES `time_unit_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `time_unit_lookup` DROP KEY `id`;
ALTER TABLE `time_unit_lookup` ADD PRIMARY KEY  (`id`);
ALTER TABLE `trigger_selection` DROP KEY (`event_ns`),,DROP KEY `event_ns`;
ALTER TABLE `trigger_selection` ADD PRIMARY KEY  (`event_ns`);
ALTER TABLE `type_workflow_map`;
ALTER TABLE `type_workflow_map` ADD `workflow_id` int(11) default NULL;
ALTER TABLE `type_workflow_map` DROP KEY `document_type_id`;
ALTER TABLE `type_workflow_map` ADD KEY `workflow_id` (`workflow_id`), ADD CONSTRAINT `type_workflow_map_ibfk_1` FOREIGN KEY (`document_type_id`) REFERENCES `document_types_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `type_workflow_map_ibfk_2` FOREIGN KEY (`workflow_id`) REFERENCES `workflows` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `units_lookup` DROP KEY `id`;
ALTER TABLE `units_lookup` ADD PRIMARY KEY  (`id`);
ALTER TABLE `units_lookup` DROP KEY `folder_id`;
ALTER TABLE `units_lookup` ADD UNIQUE KEY `folder_id` (`folder_id`), ADD CONSTRAINT `units_lookup_ibfk_1` FOREIGN KEY (`folder_id`) REFERENCES `folders` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `units_organisations_link` DROP KEY `id`,DROP KEY `fk_unit_id`,DROP KEY `fk_organisation_id`;
ALTER TABLE `units_organisations_link` ADD PRIMARY KEY  (`id`), ADD KEY `unit_id` (`unit_id`), ADD KEY `organisation_id` (`organisation_id`), ADD CONSTRAINT `units_organisations_link_ibfk_1` FOREIGN KEY (`unit_id`) REFERENCES `units_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `units_organisations_link_ibfk_2` FOREIGN KEY (`organisation_id`) REFERENCES `organisations_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `uploaded_files`;
ALTER TABLE `uploaded_files` ADD `document_id` int(11) default NULL, ADD PRIMARY KEY  (`tempfilename`), ADD KEY `userid` (`userid`), ADD KEY `document_id` (`document_id`), ADD CONSTRAINT `uploaded_files_ibfk_1` FOREIGN KEY (`userid`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `uploaded_files_ibfk_2` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `user_history` DROP FOREIGN KEY `user_history_ibfk_1`;
ALTER TABLE `user_history` ADD CONSTRAINT `user_history_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `user_history`;
ALTER TABLE `users` DROP KEY `id`;
ALTER TABLE `users` ADD PRIMARY KEY  (`id`);
ALTER TABLE `users` DROP KEY `authentication_source`,DROP KEY `authentication_details_b1`,DROP KEY `authentication_details_b2`;
ALTER TABLE `users` ADD KEY `authentication_source_id` (`authentication_source_id`);
ALTER TABLE `users` DROP FOREIGN KEY `users_ibfk_1`;
ALTER TABLE `users` ADD CONSTRAINT `users_ibfk_1` FOREIGN KEY (`authentication_source_id`) REFERENCES `authentication_sources` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `users_groups_link` DROP KEY `id`,DROP KEY `fk_user_id`,DROP KEY `fk_group_id`,DROP FOREIGN KEY `users_groups_link_ibfk_1`,DROP FOREIGN KEY `users_groups_link_ibfk_2`;
ALTER TABLE `users_groups_link` ADD PRIMARY KEY  (`id`), ADD KEY `user_id` (`user_id`), ADD KEY `group_id` (`group_id`), ADD CONSTRAINT `users_groups_link_ibfk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `users_groups_link_ibfk_2` FOREIGN KEY (`group_id`) REFERENCES `groups_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `workflow_actions` DROP KEY `workflow_id`,DROP KEY `action_name`;
ALTER TABLE `workflow_actions` ADD PRIMARY KEY  (`workflow_id`);
ALTER TABLE `workflow_documents` DROP KEY `state_id`;
ALTER TABLE `workflow_documents` ADD KEY `state_id` (`state_id`), ADD CONSTRAINT `workflow_documents_ibfk_1` FOREIGN KEY (`document_id`) REFERENCES `documents` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `workflow_documents_ibfk_2` FOREIGN KEY (`workflow_id`) REFERENCES `workflows` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `workflow_documents_ibfk_3` FOREIGN KEY (`state_id`) REFERENCES `workflow_states` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `workflow_state_actions` DROP KEY `action_name`;
ALTER TABLE `workflow_state_actions` ADD CONSTRAINT `workflow_state_actions_ibfk_1` FOREIGN KEY (`state_id`) REFERENCES `workflow_states` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `workflow_state_disabled_actions` DROP KEY `action_name`;
ALTER TABLE `workflow_state_disabled_actions` ADD CONSTRAINT `workflow_state_disabled_actions_ibfk_1` FOREIGN KEY (`state_id`) REFERENCES `workflow_states` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `workflow_state_permission_assignments` DROP FOREIGN KEY `workflow_state_permission_assignments_ibfk_7`,DROP FOREIGN KEY `workflow_state_permission_assignments_ibfk_8`;
ALTER TABLE `workflow_state_permission_assignments` ADD CONSTRAINT `workflow_state_permission_assignments_ibfk_1` FOREIGN KEY (`permission_id`) REFERENCES `permissions` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `workflow_state_permission_assignments_ibfk_2` FOREIGN KEY (`permission_descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `workflow_state_permission_assignments_ibfk_3` FOREIGN KEY (`workflow_state_id`) REFERENCES `workflow_states` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `workflow_state_transitions`;
ALTER TABLE `workflow_state_transitions` ADD `transition_id` int(11) NOT NULL default '0', ADD PRIMARY KEY  (`state_id`,`transition_id`), ADD KEY `transition_id` (`transition_id`), ADD CONSTRAINT `workflow_state_transitions_ibfk_2` FOREIGN KEY (`transition_id`) REFERENCES `workflow_transitions` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `workflow_state_transitions_ibfk_1` FOREIGN KEY (`state_id`) REFERENCES `workflow_states` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `workflow_states` DROP FOREIGN KEY `workflow_states_ibfk_1`,DROP FOREIGN KEY `workflow_states_ibfk_2`;
ALTER TABLE `workflow_states` ADD CONSTRAINT `workflow_states_ibfk_1` FOREIGN KEY (`workflow_id`) REFERENCES `workflows` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `workflow_states_ibfk_2` FOREIGN KEY (`inform_descriptor_id`) REFERENCES `permission_descriptors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `workflow_transitions` DROP KEY `workflow_id_2`,DROP KEY `workflow_id`,DROP KEY `name`;
ALTER TABLE `workflow_transitions` ADD UNIQUE KEY `workflow_id_name` (`workflow_id`,`name`);
ALTER TABLE `workflow_transitions` DROP KEY `guard_permission_id`,DROP KEY `guard_condition`;
ALTER TABLE `workflow_transitions` ADD KEY `guard_condition_id` (`guard_condition_id`);
ALTER TABLE `workflow_transitions` DROP FOREIGN KEY `workflow_transitions_ibfk_45`,DROP FOREIGN KEY `workflow_transitions_ibfk_46`,DROP FOREIGN KEY `workflow_transitions_ibfk_47`,DROP FOREIGN KEY `workflow_transitions_ibfk_48`,DROP FOREIGN KEY `workflow_transitions_ibfk_49`,DROP FOREIGN KEY `workflow_transitions_ibfk_50`;
ALTER TABLE `workflow_transitions` ADD KEY `name` (`name`), ADD KEY `guard_permission_id` (`guard_permission_id`), ADD CONSTRAINT `workflow_transitions_ibfk_1` FOREIGN KEY (`workflow_id`) REFERENCES `workflows` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `workflow_transitions_ibfk_2` FOREIGN KEY (`target_state_id`) REFERENCES `workflow_states` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `workflow_transitions_ibfk_3` FOREIGN KEY (`guard_permission_id`) REFERENCES `permissions` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `workflow_transitions_ibfk_4` FOREIGN KEY (`guard_condition_id`) REFERENCES `saved_searches` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `workflow_transitions_ibfk_5` FOREIGN KEY (`guard_group_id`) REFERENCES `groups_lookup` (`id`) ON DELETE CASCADE ON UPDATE CASCADE, ADD CONSTRAINT `workflow_transitions_ibfk_6` FOREIGN KEY (`guard_role_id`) REFERENCES `roles` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `workflow_trigger_instances` DROP KEY `namespace`;
ALTER TABLE `workflow_trigger_instances` ADD KEY `namespace` (`namespace`), ADD CONSTRAINT `workflow_trigger_instances_ibfk_1` FOREIGN KEY (`workflow_transition_id`) REFERENCES `workflow_transitions` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE `workflows` DROP FOREIGN KEY `workflows_ibfk_1`;
ALTER TABLE `workflows` ADD CONSTRAINT `workflows_ibfk_1` FOREIGN KEY (`start_state_id`) REFERENCES `workflow_states` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
